---
title: "Why Self-Host?"
date: "2021-04-16"
tags:
- blog
- tech
---

There are a variety of services out there that make it easy for anyone to set up their own "cloud". From Google Drive for storage to Medium for blogs, there are unlimited options in putting content out there. So aside as a learning experience, why would you take on the burden of running a server on your own machine?

<!-- excerpt -->

## Greater control

The big reason is to have greater control over your data. For those that are more privacy-inclined, not having to subject their content to service providers' terms and conditions may be a boon. You can control who sees your content, precisely how they see it, and reduce any bloat that providers attach to web pages.

Additionally, you gain extremely low-level access to the administration of your server, which can be  helpful if you like to tinker and fix something yourself or would like to make a deep change in how your server is configured at the OS level.

You can integrate different services more easily and run them together — for example, Syncthing ensures all of my music files are constantly kept up-to-date and accessible between my laptop, phone, and Plex.

## Custom services

On the off chance that you have a niche service that the cloud can't provide to you, you might turn to self-hosting. For example, to keep my Kobo up-to-date with any stories I add, I use Calibre-web combined with Syncthing to automatically download books as I add via my computer. It also provides a nice web interface that I can access if I happen to want to read something but don't have any of my personal devices with me.

You can also run things that normally you would have to pay a subscription fee for — large file storage and music/video/game streaming with Nextcloud and Plex/Steam respectively are just a couple of examples. Services that also charge extra for custom domain integration can also be avoided by self-hosting instead if you would like to keep it fancy. Game servers and websites come into mind.

## Limitations

Although self-hosting is certainly fun, it is subject to several issues that make it impractical for most, aside from the hardware and bandwidth/data cost.

Fairly advanced technical knowledge is required to set up such a server and maintain it without breakage. Even so, things do happen — typically after system updates — and there is also a massive time investment in a home server. It is also important to be aware of best security practices on the chance that a malicious actor could use your server to infiltrate your network. With paid services, they can largely guarantee that the underlying operating system will not break on you and that security is taken care of. This is amplified as your website or service becomes more popular.

## Conclusion

Running your own server is a lot of work. But it puts my old computer to good use, and has personally helped me a lot in learning more about how our world today operates, even if I only get a small glimpse in that world. My Optiplex provides a variety of helpful services that I regularly use and some that I would not be able to obtain otherwise in exchange for a large chunk of my time. Depending on your circumstances, however, you might be better off relying on others instead. It's a good idea to weigh the pros and cons of investing any monetary resources or time into such an idea.